﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#IgnoreWarnings:12
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private SDMenu As MenuBar
	Private SDSplit As SplitPane
	Private SDWebView As WebView
	Private SDPane As TabPane
	Private SDTreeTable As TreeTableView
	Private fx As JFX
	'Private DragDrop As DragAndDrop
	'Private SDComponents As Accordion
	Private leftSplit As SplitPane
	'Private WebViewExtras1 As WebViewExtras
	'Private pg As htmlpage
	Private Dollar As String = "$"
	Private propBag As B4XTable
	Private ie As InlineEditing
	Private TextField1 As B4XView	
	Private B4XPlusMinus1 As B4XPlusMinus
	Private Numbers As Map
	Private colDetails As B4XTableColumn
	Private colValue As B4XTableColumn
	Private Choices As Map
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
	'create a folder for resources
	File.MakeDir(File.DirApp, "resources")
End Sub


'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	FullScreen
	'load the main layout
	Root.LoadLayout("MainPage")
	
	'WebViewExtras1.Initialize(SDWebView)
	'load the left side
	SDSplit.LoadLayout("leftSide")
	SDSplit.LoadLayout("centerSide")
	SDSplit.LoadLayout("rightSide")
	SDPane.LoadLayout("propslayout", "Properties")
		
	Root.LoadLayout("Controls")
	ie.Initialize(propBag, Me, "ie")
	TextField1.RemoveViewFromParent
	B4XPlusMinus1.mBase.RemoveViewFromParent
	'trap dividerPosition change event
	Dim jo As JavaObject
	jo = SDSplit
	addPositionChangedEvent(jo.RunMethodJO("getDividers",Null).RunMethodJO("get",Array(0)),"dividerPosition")
	
	'limit the widths of the two side layouts
	SDSplit.SetSizeLimits(0, 10, 400)
	SDSplit.SetSizeLimits(2, 10, 400)
	'
	SDTreeTable.SetColumnWidth(0, 400)

	'adjust the size of the treeview
	'get the width of the first item
	Dim nWidth As Int = SDSplit.DividerPositions(0) * SDSplit.Width
	'apply sizee to tree
	SDTreeTable.SetColumnWidth(0, nWidth)
	
	'
	propBag.Clear
	Sleep(0)
	propBag.lblFirst.Parent.Visible = False
	'propBag.SearchVisible = False
	'
	PagePropBag
End Sub

'show property bag for a page
Sub PagePropBag
	Numbers.Initialize
	Choices.Initialize
	propBag.Clear
	Sleep(0)
	propBag.lblFirst.Parent.Visible = False
	'propBag.SearchVisible = False
	
	colDetails = propBag.AddColumn("Details", propBag.COLUMN_TYPE_TEXT)
	colDetails.Sortable = False
	colDetails.Width = 100dip
	colValue = propBag.AddColumn("Value", propBag.COLUMN_TYPE_TEXT)
	colValue.Sortable = False
	'
	propBag.HeaderFont = xui.CreateDefaultBoldFont(12)
	propBag.LabelsFont = xui.CreateDefaultFont(12)
	'
	propBag.MaximumRowsPerPage = 10
	propBag.BuildLayoutsCache(propBag.MaximumRowsPerPage)
	propBag.HighlightSearchResults = False
	'
	SetColumnHorizontalAlignment(colDetails, "left")
	SetColumnHorizontalAlignment(colValue, "center")
	'
	Dim data As List
	data.Initialize
	
	data.Add(Array("Name", "index"))
	data.Add(Array("Page Tag", "div"))
	data.Add(Array("Title", "Home"))
	data.Add(Array("Icon", "logo-ionic"))
	data.Add(Array("Row", 1))
	data.Add(Array("Column", 1))
	data.Add(Array("Active", "yes"))
	data.Add(Array("Save", "Apply"))
	propBag.SetData(data)
	'
	'define all numeric fields
	Numbers.Put("Row", "")
	Numbers.Put("Column", "")
	'define all switches
	Choices.Put("Active", "")
	Choices.Put("Page Tag", "")
	
	
'	For i = 1 To colValue.CellsLayouts.Size - 1 'add custom check box to table
'		'Sleep(0)
'		Dim pnl As B4XView = colValue.CellsLayouts.Get(i)
'		Dim ColCheckBox As CheckBox
'		ColCheckBox.Initialize("")
'		St.SetButtonTintList(ColCheckBox,Colors.Gray,SysDeclare.COLOR_DARK_NAVY)
'		pnl.AddView(ColCheckBox, 5dip, 5dip, CheckColumn.Width - 10dip, tblPhoneContacts.RowHeight - 10dip)
'	Next
'	
	
End Sub


Sub ComponentPropBag
'	ResizePropBag
'	AS_Properties.DeleteAllProperties
'	propBag.AddGroup("Basic","Basic Settings")
'	propBag.AddProperty_Text("Basic", "componentname", "Component Name", "" , Null, "Test", 300dip, propBag.InputType_Text)
'	propBag.Create
End Sub


Sub addPositionChangedEvent(divider As Object,eventName As String)
	Dim Obj As Reflector
	Obj.Target = divider
	Obj.AddChangeListener(eventName, "positionProperty")
End Sub

Sub dividerPosition_changed(old As Object, new As Object)
	'get the width of the first item
	Dim nWidth As Int = SDSplit.DividerPositions(0) * SDSplit.Width
	'apply sizee to tree
	SDTreeTable.SetColumnWidth(0, nWidth)
	'resize the propbag also
'	propBag.Base_Resize(SDPane.Width, SDPane.Height)
End Sub


'make the form full screen
Sub FullScreen
	Dim f As Form = B4XPages.GetNativeParent(Me)
	f.WindowWidth = fx.PrimaryScreen.MaxX - fx.PrimaryScreen.MinX
	f.WindowLeft = fx.PrimaryScreen.MinX
	f.WindowHeight = fx.PrimaryScreen.MaxY - fx.PrimaryScreen.MinY
	f.WindowTop = fx.PrimaryScreen.MinY
End Sub

'
Private Sub SDMenu_Action
	
End Sub

Private Sub SDMenu_SelectedChange (Selected As Boolean)
	
End Sub

'Private Sub SDWebView_LocationChanged (Location As String)
'	xui.MsgboxAsync("Page location changed!", "Page")
'End Sub
'
Private Sub SDWebView_PageFinished (Url As String)
	'get the complete html for the page
	'Dim pgHTML As String = pg.WebViewHTML
	'Log(pgHTML)
	'execute any js code on the file
	'If pg.jsCode <> "" Then
	'	Wait For (RunJavaScript(pg.jsCode)) Complete(Html As Object)
	'End If
End Sub

Private Sub SDPane_TabChanged (SelectedTab As TabPage)
	
End Sub


Private Sub SDSplit_Resize (Width As Double, Height As Double)
	ResizePropBag
End Sub

Sub ResizePropBag
'	Dim nWidth As Int = SDSplit.DividerPositions(1) * SDSplit.Width
'	propBag.Base_Resize(nWidth, SDPane.Height)
	ie.TableResized
End Sub

Sub propbag_CellClicked (ColumnId As String, RowId As Long)
	Dim row As Map = propBag.GetRow(RowId)
	Dim sValue As String = row.Get("Value")
	Select Case sValue
	Case "Apply"
		If ie.IsInEditingState Then ie.ExitEditMode
		Dim bag As Map = GetPropertyBag
		Log(bag)
		Return	
	End Select
	
	Select Case ColumnId
	Case "Details"
		If ie.IsInEditingState Then ie.ExitEditMode
		Return	
	End Select
	If ColumnId <> "Value" Then Return
	'avoid calling ie.CellClicked if the column is not editable.
	ie.CellClicked(ColumnId, RowId)
End Sub

Sub propbag_DataUpdated
	Try
		ie.DataUpdated
		'Dim pdata As Map = GetPropertyBag
		'Log(pdata)
'		Sleep(0)
'		For i = 0 To propBag.VisibleRowIds.Size - 1
'			Dim RowId As Long = propBag.VisibleRowIds.Get(i)
'			Dim pnl As B4XView = colValue.CellsLayouts.Get(i + 1) '+1 because first cell is a header
'		
'			If RowId > 0 Then
'				Dim row As Map = propBag.GetRow(RowId)
'				Dim sDetails As String = row.Get("Details")
'				Dim sValue As String = row.Get("Value")
'				Log(sDetails)
'				Log(sValue)
'				'		
'				If Numbers.ContainsKey(sDetails) Then
'					Dim plusminus As B4XPlusMinus
'					plusminus.Initialize(Me, "")
'					plusminus.SelectedValue = sValue
'					plusminus.SetNumericRange(0, 100, 1)
'					plusminus.Tag = sDetails
'					pnl.AddView(plusminus.mBase, 5dip, 5dip, colValue.Width-5dip, propBag.RowHeight - 10dip)
''					B4XPlusMinus1.SelectedValue = FC.PrevValue
''					FC.View = B4XPlusMinus1.mBase
'					Return
'				End If
'				'use switch
'				If Switches.ContainsKey(sDetails) Then
''					If 0 = FC.PrevValue Then B4XSwitch1.Value = False
''					If 1 = FC.PrevValue Then B4XSwitch1.Value = True
'					'FC.View = B4XSwitch1.mbase
'					Return
'				End If
'				If Choices.ContainsKey(sDetails) Then
'					Dim choice As B4XPlusMinus
'					choice.Initialize(Me, "")
'					choice.SelectedValue = sValue
'					choice.Tag = sDetails
'					pnl.AddView(plusminus.mBase, 5dip, 5dip, colValue.Width-5dip, propBag.RowHeight - 10dip)
'					Select Case sDetails
'					Case "Page Tag"
'						choice.SetStringItems(Array("div", "ion-content"))
'						Return
'					End Select
'					Return
'				End If
'				'add text box
'				Dim txtBox As TextField
'				txtBox.Initialize(sDetails)
'				txtBox.Text = sValue
'				txtBox.Tag = sDetails
'				pnl.AddView(txtBox, 5dip, 5dip, colValue.Width-5dip, propBag.RowHeight - 10dip)
'				
'				
'				'Log(row)
'				'If ColCheckBox.Checked Then
'				'	Log($"Checked rowid ${RowId} "$)
'				'                Log($"rowid ${RowId}   ${row.Get("Name")}"$)  'Name is header of another column to display
'				'End If
'			End If
'		Next
'		
'		
	Catch
		
	End Try	'ignore	
End Sub

Private Sub IE_EnterEditMode (FC As FocusedCell)
	Try
		'get the row of data
		Dim rowData As Map = propBag.GetRow(FC.RowId)
		'get the details content
		Dim sDetails As String = rowData.Get("Details")
		'FC.PrevValue holds the current value. It can also be used later to revert changes
		Select FC.ColumnId
		Case "Value"
			'use numeric
			If Numbers.ContainsKey(sDetails) Then
				B4XPlusMinus1.SetNumericRange(0, 100, 1)
				B4XPlusMinus1.SelectedValue = FC.PrevValue
				FC.View = B4XPlusMinus1.mBase
				Return
			End If
			'use switch
			If Choices.ContainsKey(sDetails) Then
				Select Case sDetails
				Case "Page Tag"
					B4XPlusMinus1.SetStringItems(Array("div", "ion-content"))
					B4XPlusMinus1.SelectedValue = FC.PrevValue
					FC.View = B4XPlusMinus1.mBase
					Return
				Case "Active"
					B4XPlusMinus1.SetStringItems(Array("yes", "no"))
					B4XPlusMinus1.SelectedValue = FC.PrevValue
					FC.View = B4XPlusMinus1.mBase
					Return
				End Select
			End If
			'default to text
			SetTextField
			TextField1.Text = FC.PrevValue
			FC.View = TextField1
		End Select
	Catch
		
	End Try	'ignore		
		
End Sub

Private Sub IE_GetUpdatedValue (FC As FocusedCell) As Object
	Try
		'get the row of data
		Dim rowData As Map = propBag.GetRow(FC.RowId)
		'get the details content
		Dim sDetails As String = rowData.Get("Details")
		Select FC.ColumnId
		Case "Value"
			If Numbers.ContainsKey(sDetails) Then Return NumberFormat(B4XPlusMinus1.SelectedValue,1,0)
			If Choices.ContainsKey(sDetails) Then Return B4XPlusMinus1.SelectedValue
			'default to text
			Return TextField1.Text
		End Select
	Catch
		Return Null
	End Try		
	Return Null
End Sub

Private Sub SetTextField
	Try
		TextField1.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
		Dim tf As TextField = TextField1
		Sleep(0)
		tf.SelectAll
	Catch
		
	End Try		'ignore		
End Sub

Sub TextField1_Action
	Try
		ie.ExitEditMode
	Catch
	End Try	'ignore		
End Sub

Sub TextField1_TextChanged (Old As String, New As String)
'	If ie.IsInEditingState And ie.CurrentlyFocusedCell.ColumnId = "Date" Then
'		Try
'			DateTime.DateParse(New)
'			TextField1.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
'		Catch
'			TextField1.SetColorAndBorder(xui.Color_Transparent, 2, xui.Color_Red, 0)
'		End Try
'	End If
End Sub

Private Sub SetColumnHorizontalAlignment(Col As B4XTableColumn, Alignment As String)
	For i = 1 To Col.CellsLayouts.Size - 1
		Dim p As B4XView = Col.CellsLayouts.Get(i)
		p.GetView(Col.LabelIndex).SetTextAlignment("CENTER", Alignment.ToUpperCase)
	Next
End Sub

'get values of the property bag
Sub GetPropertyBag As Map
	Dim nm As Map = CreateMap()
	Dim i As Int = 0
	For i = 1 To propBag.Size
		Dim Row As Map = propBag.GetRow(i)
		Dim key As String = Row.Get("Details")
		Dim value As String = Row.Get("Value")
		nm.Put(key, value)
	Next
	Return nm
End Sub

